/*
 * $Id$
 */

package npanday.model.entries.io.xpp3;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.Writer;
import java.text.DateFormat;
import java.util.Iterator;
import java.util.Locale;
import npanday.model.entries.Entries;
import npanday.model.entries.Entry;
import org.codehaus.plexus.util.xml.pull.MXSerializer;
import org.codehaus.plexus.util.xml.pull.XmlSerializer;

/**
 * Class EntriesXpp3Writer.
 * 
 * @version $Revision$ $Date$
 */
public class EntriesXpp3Writer {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field NAMESPACE
     */
    private String NAMESPACE;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method write
     * 
     * @param writer
     * @param entries
     */
    public void write(Writer writer, Entries entries)
        throws java.io.IOException
    {
        XmlSerializer serializer = new MXSerializer();
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-indentation", "  " );
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-line-separator", "\n" );
        serializer.setOutput( writer );
        serializer.startDocument( entries.getModelEncoding(), null );
        writeEntries( entries, "Entries", serializer );
        serializer.endDocument();
    } //-- void write(Writer, Entries) 

    /**
     * Method writeEntries
     * 
     * @param entries
     * @param serializer
     * @param tagName
     */
    private void writeEntries(Entries entries, String tagName, XmlSerializer serializer)
        throws java.io.IOException
    {
        if ( entries != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( entries.getEntry() != null && entries.getEntry().size() > 0 )
            {
                serializer.startTag( NAMESPACE, "entry" );
                for ( Iterator iter = entries.getEntry().iterator(); iter.hasNext(); )
                {
                    Entry o = (Entry) iter.next();
                    writeEntry( o, "entry", serializer );
                }
                serializer.endTag( NAMESPACE, "entry" );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeEntries(Entries, String, XmlSerializer) 

    /**
     * Method writeEntry
     * 
     * @param entry
     * @param serializer
     * @param tagName
     */
    private void writeEntry(Entry entry, String tagName, XmlSerializer serializer)
        throws java.io.IOException
    {
        if ( entry != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( entry.getSchedule() != null )
            {
                serializer.startTag( NAMESPACE, "schedule" ).text( entry.getSchedule() ).endTag( NAMESPACE, "schedule" );
            }
            if ( entry.getGroupId() != null )
            {
                serializer.startTag( NAMESPACE, "groupId" ).text( entry.getGroupId() ).endTag( NAMESPACE, "groupId" );
            }
            if ( entry.getArtifactId() != null )
            {
                serializer.startTag( NAMESPACE, "artifactId" ).text( entry.getArtifactId() ).endTag( NAMESPACE, "artifactId" );
            }
            if ( entry.getVersion() != null )
            {
                serializer.startTag( NAMESPACE, "version" ).text( entry.getVersion() ).endTag( NAMESPACE, "version" );
            }
            if ( entry.getChangeto() != null )
            {
                serializer.startTag( NAMESPACE, "changeto" ).text( entry.getChangeto() ).endTag( NAMESPACE, "changeto" );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeEntry(Entry, String, XmlSerializer) 

}
